<template>
  <q-btn label="Ustawienia" color="primary" @click="settings = true" />
  <q-dialog v-model="settings">
    <q-card>
      <q-card-section>
        <div class="text-h6">Kogo szukam?</div>
      </q-card-section>

      <q-card-section class="q-pt-none">
        Osoby w jakim wieku Cię interesują?
        <q-range v-model="ageRange" :min="18" :max="120" />
        <div class="range">
          <p>{{ ageRange.min }}</p>
          <p>{{ ageRange.max }}</p>
        </div>
      </q-card-section>
      <q-card-section class="q-pt-none">
        Jaką dopuszczasz odległość? (mierzoną od centrum Twojej miejscowości)
        <q-slider v-model="distance" :min="0" :max="2000" />
        <p>{{ distance }}</p>
      </q-card-section>

      <q-card-actions align="right">
        <q-btn @click="save" label="Zapisz" color="primary" v-close-popup />
        <q-btn
          @click="
            () => {
              settings = false;
            }
          "
          label="Anuluj"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>
<script setup lang="ts">
import { ref } from 'vue';

import { api } from '../boot/axios';
import { useUserStore } from '../stores/user';

defineOptions({
  name: 'SettingsComponent',
});
interface Range {
  min: number;
  max: number;
}

const userStore = useUserStore();
const { user } = userStore;
const settings = ref<boolean>(false);
const ageRange = ref<Range>({
  min: user.ageRange ? user.ageRange[0] : 30,
  max: user.ageRange ? user.ageRange[1] : 60,
});
const distance = ref<number>(user.distance);

function save() {
  api
    .put('/user/settings', {
      uuid: user.uuid,
      distance: distance.value,
      ageRange: [ageRange.value.min, ageRange.value.max],
    })
    .then(({ data }) => {
      console.log(data);
    })
    .catch((err) => {
      console.error(err);
    });
}
</script>
<style scoped lang="scss">
.range {
  display: flex;
  flex-direction: row;
  & > *:nth-child(2) {
    margin-left: 10px;
  }
}
</style>
